package ixpce;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import javax.microedition.io.Connector;

import com.nttdocomo.ui.Display;

public class Config {
	public static int pad1A;
	public static int pad1B;
	public static int pad1Select;
	public static int pad1Start;
	public static int pad1Up;
	public static int pad1Down;
	public static int pad1Left;
	public static int pad1Right;
	public static int keyStateSave;
	public static int keyStateLoad;
	public static int keyUp;
	public static int keyDown;
	public static int keyOK;
	public static int keyCancel;
	public static int keyMenu;
	public static int keyPadSetting;
	public static boolean pad1AHold;
	public static boolean pad1BHold;
	public static boolean pad1ARapid;
	public static boolean pad1BRapid;
	public static int frameSkip;
	public static boolean sleepEnable;
	public static boolean vSyncWaitEnable;
	public static boolean dispFPSEnable;
	public static int APUMode1;
	public static int APUMode2;
	public static int APUVolume;
	public static int APUBuffer;
	public static boolean APUEnable;
	public static boolean APUStereoEnable;
	
	/**
	 * ݒlݒ肵܂B
	 */
	public static void setupDefault() {
		pad1A = (1 << Display.KEY_3);
		pad1B = (1 << Display.KEY_2);
		pad1Select = (1 << Display.KEY_5);
		pad1Start = (1 << Display.KEY_6);
		pad1Up = (1 << Display.KEY_UP);
		pad1Down = (1 << Display.KEY_DOWN);
		pad1Left = (1 << Display.KEY_LEFT);
		pad1Right = (1 << Display.KEY_RIGHT);
		keyStateSave = (1 << Display.KEY_1);
		keyStateLoad = (1 << Display.KEY_4);	
		keyUp = (1 << Display.KEY_UP) | (1 << Display.KEY_RIGHT);
		keyDown = (1 << Display.KEY_DOWN) | (1 << Display.KEY_LEFT);
		keyOK = (1 << Display.KEY_SELECT);
		keyCancel = (1 << Display.KEY_IAPP);
		keyMenu = (1 << Display.KEY_SOFT1);
		keyPadSetting = (1 << Display.KEY_SOFT2);
		pad1AHold = false;
		pad1BHold = false;
		pad1ARapid = false;
		pad1BRapid = false;
		frameSkip = 2;
		sleepEnable = false;
		vSyncWaitEnable = false;
		dispFPSEnable = false;	
		APUMode1 = 0;
		APUMode2 = 0;
		APUVolume = 100;
		APUBuffer = 15;
		APUEnable = true;
		APUStereoEnable = true;
	}
	
	/**
	 * ɂꍇ̃L[ݒlw肵܂B
	 */
	public static void setupKeysHorizontial()
	{
		pad1A = (1 << Display.KEY_0);
		pad1B = (1 << Display.KEY_8);
		pad1Select = (1 << Display.KEY_2);
		pad1Start = (1 << Display.KEY_5);
		pad1Up = (1 << Display.KEY_RIGHT);
		pad1Down = (1 << Display.KEY_LEFT);
		pad1Left = (1 << Display.KEY_UP);
		pad1Right = (1 << Display.KEY_DOWN);
	}
	
	/**
	 * ݒlXNb`pbh烍[h܂B
	 * @return
	 */
	public static boolean load() {
		DataInputStream input = null;
		try {
			input = Connector.openDataInputStream("scratchpad:///0;pos=0");
			if (input == null) {
				return false;
			}
			if (!(input.readChar() == 'C'
				&& input.readChar() == 'O'
				&& input.readChar() == 'N'
				&& input.readChar() == 'F')) {
				return false;
			}
			pad1A = input.readInt();
			pad1B = input.readInt();
			pad1Select = input.readInt();
			pad1Start = input.readInt();
			pad1Up = input.readInt();
			pad1Down = input.readInt();
			pad1Left = input.readInt();
			pad1Right = input.readInt();
			keyStateSave = input.readInt();
			keyStateLoad = input.readInt();
			keyUp = input.readInt();
			keyDown = input.readInt();
			keyOK = input.readInt();
			keyCancel = input.readInt();
			keyMenu = input.readInt();
			keyPadSetting = input.readInt();
			pad1AHold = input.readBoolean();
			pad1BHold = input.readBoolean();
			pad1ARapid = input.readBoolean();
			pad1BRapid = input.readBoolean();
			frameSkip = input.readInt();
			sleepEnable = input.readBoolean();
			vSyncWaitEnable = input.readBoolean();
			dispFPSEnable = input.readBoolean();
			APUMode1 = input.readInt();
			APUMode2 = input.readInt();
			APUVolume = input.readInt();
			APUBuffer = input.readInt();
			APUEnable = input.readBoolean();
			APUStereoEnable = input.readBoolean();
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		} finally {
			try {
				if (input != null) {
					input.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
				return false;
			}
		}
		return true;
	}
	
	/**
	 * ݒlXNb`pbh֕ۑ܂B
	 * @return
	 */
	public static boolean save(){
		DataOutputStream output = null;
		try {
			output = Connector.openDataOutputStream("scratchpad:///0;pos=0");
			output.writeChars("CONF");
			output.writeInt(pad1A);
			output.writeInt(pad1B);
			output.writeInt(pad1Select);
			output.writeInt(pad1Start);
			output.writeInt(pad1Up);
			output.writeInt(pad1Down);
			output.writeInt(pad1Left);
			output.writeInt(pad1Right);
			output.writeInt(keyStateSave);
			output.writeInt(keyStateLoad);
			output.writeInt(keyUp);
			output.writeInt(keyDown);
			output.writeInt(keyOK);
			output.writeInt(keyCancel);
			output.writeInt(keyMenu);
			output.writeInt(keyPadSetting);
			output.writeBoolean(pad1AHold);
			output.writeBoolean(pad1BHold);
			output.writeBoolean(pad1ARapid);
			output.writeBoolean(pad1BRapid);
			output.writeInt(frameSkip);
			output.writeBoolean(sleepEnable);
			output.writeBoolean(vSyncWaitEnable);
			output.writeBoolean(dispFPSEnable);
			output.writeInt(APUMode1);
			output.writeInt(APUMode2);
			output.writeInt(APUVolume);
			output.writeInt(APUBuffer);
			output.writeBoolean(APUEnable);
			output.writeBoolean(APUStereoEnable);
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		} finally {
			try {
				output.close();
			} catch (IOException e) {
				e.printStackTrace();
				return false;
			}
		}
		return true;
	}
}
