package ixpce;

import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.Image;
import com.nttdocomo.ui.MediaImage;
import com.nttdocomo.ui.MediaManager;

public class GFont {
	private static final int IMG_DIV_COUNT = 16;
	private Image fontImage;
	private Image bgImage;
	private int fontWidth;
	private int fontHeight;
	
	public int getFontWidth() {
		return this.fontWidth;
	}
	
	public int getFontHeight() {
		return this.fontHeight;
	}
	
	public GFont() {
		try
		{
		    MediaImage mi = MediaManager.getImage("resource:///font.gif");
		    mi.use();   
		    fontImage = mi.getImage();
		    
		    mi = MediaManager.getImage("resource:///ixpce.gif");
		    mi.use();   
		    bgImage = mi.getImage();
		    
		    fontWidth = fontImage.getWidth() / IMG_DIV_COUNT;
		    fontHeight = fontImage.getHeight() / IMG_DIV_COUNT;
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void DrawString(Graphics g, String msg, int baseX, int baseY) {
		int dx = baseX;
		int dy = baseY;
		
		for (int i = 0; i < msg.length(); i++) {
			char c = msg.charAt(i);
			
			if (c == '\n') {
				dx = baseX;
				dy += fontHeight;
				continue;
			}
			
			int charIndex = c - (char)' ';
			int indexX = charIndex % IMG_DIV_COUNT;
			int indexY = charIndex / IMG_DIV_COUNT;
			int sx = fontWidth * indexX;
			int sy = fontHeight * indexY;
			g.drawImage(fontImage, dx, dy, sx, sy, fontWidth - 1, fontHeight - 1);
			
			dx += fontWidth;
		}
	}
	
	public void drawBackGround(Graphics g, int width, int height) {
		
		// wiNA
		g.clearRect(0, 0, width, height);
		
		// ɔwiC[W`
		int dx = (width - bgImage.getWidth()) / 2;
		int dy = 0; //(height - bgImage.getHeight()) / 2;
		g.drawImage(bgImage, dx, dy);
	}
}
