package ixpce;

class Joystick {
	
	public static final int JOY_A = 1;
	public static final int JOY_B = 2;
	public static final int JOY_SELECT = 4;
	public static final int JOY_START = 8;
	public static final int JOY_UP = 0x10;
	public static final int JOY_DOWN = 0x40;
	public static final int JOY_LEFT = 0x80;
	public static final int JOY_RIGHT = 0x20;
	
	private MainCanvas canvas;
	
	public Joystick(MainCanvas canvas) {
		this.canvas = canvas;
	}
	
	public int getState() {
		int joy = 0;
		
		int state = canvas.getKeypadState();
		
		state = canvas.PadRapidAndHold(state);
		
		if ((state & Config.pad1A) != 0) {
			joy |= JOY_A;
		}
		if ((state & Config.pad1B) != 0) {
			joy |= JOY_B;
		}
		if ((state & Config.pad1Select) != 0) {		
			joy |= JOY_SELECT;
		}
		if ((state & Config.pad1Start) != 0) {
			joy |= JOY_START;
		}
		if ((state & Config.pad1Up) != 0) {
			joy |= JOY_UP;
		}
		if ((state & Config.pad1Down) != 0) {
			joy |= JOY_DOWN;
		}
		if ((state & Config.pad1Left) != 0) {
			joy |= JOY_LEFT;
		}
		if ((state & Config.pad1Right) != 0) {
			joy |= JOY_RIGHT;
		}
		
		return joy;
	}
}
