package ixpce;

import com.nttdocomo.ui.Graphics;

public class Render {
	private int width;
	private int height;
	private int[] palTable = new int[256];
	private int buffer32[];
	
	public Render(int width, int height) {
		this.width = width;
		this.height = height;
		this.buffer32 = new int[width * height];
		
		CreatePaletteTable();
	}
	
	public void CreatePaletteTable() {
		for (int i = 0; i < palTable.length; i++)
		{
			palTable[i] = ((((i >> 2) & 7) * 36) << 16) & 0x00FF0000;
			palTable[i] |= (((i >> 5) * 36) << 8) & 0x0000FF00;
			palTable[i] |= (((i & 3) * 84) << 0) & 0x000000FF;
		}
		
		// pbgf[^zRGBlAgщʂ̐F[x̐[ɂ킹ăXP[
		// lōĐݒ肵܂
		for (int i = 0; i < palTable.length; i++) {
			int rgb = palTable[i];
			palTable[i] = Graphics.getColorOfRGB((rgb >> 16) & 0xff,
					(rgb >> 8) & 0xff, rgb & 0xff);
		}
	}
		
	public void DrawVramImage(byte[] buffer8, int offX, int offY, int width, int height) {
		final int buffer32[] = this.buffer32;
		final int palTable[] = this.palTable;
		
		int index = offY * this.width;
		int indexYEnd = height * this.width;
		do {
			index += offX;
			int indexXEnd= index + width;
			do {
				buffer32[index    ] = palTable[buffer8[index    ] & 0xFF];
				buffer32[index + 1] = palTable[buffer8[index + 1] & 0xFF];
				buffer32[index + 2] = palTable[buffer8[index + 2] & 0xFF];
				buffer32[index + 3] = palTable[buffer8[index + 3] & 0xFF];
				index += 4;				
			} while (index < indexXEnd);
			index += (this.width - width - offX);
		} while (index < indexYEnd);
	}
	
	public int[] getBuffer32() {
		return buffer32;
	}
}
