package ixpce;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Vector;

import javax.microedition.io.Connector;

import com.nttdocomo.io.BufferedReader;

public class Resource {
	
	private DataInputStream is = null;
	private InputStreamReader isr = null;
	private BufferedReader br = null;

	private boolean open(String fileName) {
		try {
			is = Connector.openDataInputStream("resource:///" + fileName);
			isr = new InputStreamReader(is);
			br = new BufferedReader(isr);
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}
		
		return true;
	}
	
	private void close() {
		try {
			if (br != null) {
				br.close();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		try {
			if (isr != null) {
				isr.close();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		try {
			if (is != null) {
				is.close();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public Vector loadRomList() {
		if (!open("romlist.txt")) {
			return null;
		}
		
		Vector vec = new Vector();
		
		try {
			for (;;) {
				String str = br.readLine();
				if (str == null) {
					break;
				}
				int index = str.indexOf("\t");
				if (index == -1) {
					continue;
				}
				String hash = str.substring(0, index);
				String title = str.substring(index + 1);
				RomTitle romTitle = new RomTitle(title, hash);
				vec.addElement(romTitle);
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		} finally {
			close();
		}
		
		return vec;
	}
}
