package ixpce;
import java.io.*;

import com.nttdocomo.io.*;
import com.nttdocomo.fs.*;
import com.nttdocomo.device.*;

public final class SDbinding{

    private Folder roms;
    private FileEntity fe;

    public SDbinding(){
        // tH_[擾
        try{
            StorageDevice sd = StorageDevice.getInstance("/ext0");
            //ANZXݒ薳AAv̂ݗp̍łPȎw
            roms = sd.getFolder(
                (AccessToken)DoJaStorageService.getAccessToken(0,DoJaStorageService.SHARE_APPLICATION ) );
        }catch(Exception e){
            roms = null;
            //System.out.println("getFolder err : "+e.toString());
        }
        fe = null;
    }

    public final void createFile(String imest){
        // _~[t@C쐬
        FileEntity fe2 = null;
        OutputStream oss = null;
        if(roms != null) {
            try{
                roms.createFile(imest);
                File fl = roms.getFile(imest);
                fe2 = fl.open( File.MODE_WRITE_ONLY );
                oss = fe2.openOutputStream();
                byte test [] = new byte[256];
                oss.write(test);
                oss.flush();
            }catch(Exception e){
                //System.out.println("create err : "+e.toString());
            }finally{
                try{
                    oss.close();
                }catch(Exception e){}
                oss=null;
                try{
                    fe2.close();
                }catch(Exception e){}
                fe2=null;
            }
        }
    }

    public final InputStream openInputStream(String filenm){
        // t@CǍ(ROM)
        InputStream is = null;
        close();
        if(roms != null){
            try{
                File fl = roms.getFile(filenm);
                long length = fl.getLength();
                fe = fl.open( File.MODE_READ_ONLY );
                is = fe.openInputStream();

                //q[veʂ܂ĂSǂݍłB͓KB
                if( Runtime.getRuntime().totalMemory() > length * 2 + 1024 * 2 ){
                    byte[] buf = new byte[(int)length];
                    is.read(buf);
                    is.close();
                    is = null;
                    System.gc();
                    ByteArrayInputStream bin = new ByteArrayInputStream(buf);
                    is = new DataInputStream(bin);
                    buf = null ;
                    bin.close();
                    bin = null ;
                    System.gc();
                }
            }catch(Exception e){
                //System.out.println("SD rom open err : "+e.toString());
            }
        }
        return is;
    }

    public final void deleteFile(String imest){
        // t@C폜
        close();
        if(roms != null) {
            try{
                File fl = roms.getFile(imest);
                fl.delete();
            }catch(Exception e){
                //System.out.println("delete err : "+e.toString());
            }
        }
    }

    public final DataInputStream openDataInputStream(String filenm){
        // t@CǍ
        DataInputStream iss = null;
        close();
        if(roms != null) {
            try{
                close();
                File fl = roms.getFile(filenm);
                fe = fl.open( File.MODE_READ_ONLY );
                iss = new DataInputStream(fe.openInputStream());
            }catch(Exception e){
                //System.out.println("SD file open err : "+e.toString());
            }
        }
        return iss;
    }

    public final DataOutputStream openDataOutputStream(String filenm){
        // t@C
        DataOutputStream oss = null;
        close();
        if(roms != null){
            try{
                File fl = null;
                try{
                    fl = roms.getFile(filenm);
                }catch(FileNotAccessibleException e){
                    fl = null;
                }catch(Exception e){
                    return null;
                }
                if (fl == null) {
                    roms.createFile(filenm);
                    fl = roms.getFile(filenm);
                }
                fe = fl.open( File.MODE_WRITE_ONLY );
                oss = new DataOutputStream(fe.openOutputStream());
            }catch(Exception e){
                //System.out.println("SD file open err : "+e.toString());
            }
        }
        return oss;
    }
    
    public final long getLastModified(String filenm){
        long modified = 0;
    	if(roms != null) {
            try{
                File fl = roms.getFile(filenm);
                modified = fl.getLastModified();
            }catch(Exception e){
                //System.out.println("SD file open err : "+e.toString());
            }
        }
        return modified;
    }

/*
    public static void closeFileEntry(){
        // t@CGg[̃N[Y
        if(fe != null){
            try{
                fe.close();
            }catch(Exception e2){
                //System.out.println("SD fe close err : "+e2.toString());
            }
            fe = null ;
        }
    }
*/

    public final long sdGetFreeSize(){
        // eʎ擾
        long sz = 0;
        if(roms != null) {
            try {
                sz = roms.getFreeSize();
            }catch(Exception e){}
        }
        return sz;
    }
    
    public final void close(){
        if(fe != null) {
            try{
                fe.close();
            }catch(Exception e){}
            fe = null;
        }
    }
}
