package wsx2;
import com.nttdocomo.ui.*;
import java.io.*;
import javax.microedition.io.Connector;

public class NESApu1 implements NESApu {

    /*萔*/
    static final int MODE_PRESET = 0;
    static final int MODE_YAMAHA = 1;
    static final int MODE_ROHM  = 2;
    static final int MODE_CUSTOM = 3;
    static final int CH_PWG1 = 0;
    static final int CH_PWG2 = 1;
    static final int CH_TWG = 2;
    static final int CH_NWG = 3;

    private final int TRACKBUFFER_SIZE = 1024;
    private final int TRACKBUFFER_MAXFRAMECOUNT = 15;

    private final int MLD_PWG_PROGRAMNUM[] = { 0,1,2,1 };
    private final int MLD_TWG_PROGRAMNUM = 3;
    private final int MLD_NWG_PROGRAMNUM[] = { 4, 4 };

    private final int MLD_PWG_VOL[] = { 0,7,10,14,19,22,25,28,32,34,36,38,40,42,44,46 };
    private final int MLD_TWG_VOL[] = { 0,40 };
    private final int MLD_NWG_VOL[] = { 0,5,7,9,11,13,15,17,19,21,23,25,27,29,31,33 };
    /*
    private final int MLD_PWG_VOL[] = { 0,15,20,24,28,32,36,39,42,44,46,48,50,52,54,56 };
    private final int MLD_TWG_VOL[] = { 0,51 };
    private final int MLD_NWG_VOL[] = { 0,15,20,25,29,33,37,40,44,46,48,50,52,54,56,58 };
    */
    private final int MLD_NWG_NOTENUM[] = { 3,8,12,17,20,24,29,34,34,34,34,34,34,34,34,34 };
    //private final int MLD_NWG_NOTENUM[] = { 0,2,3,5,7,8,10,12,14,15,17,19,20,22,24,26 };
    private final int MLD_NOTEVELOCITY_VAL = 0xFC;
    private final int MLD_NOTE_DURATION = 3;

    /*  sb`vZp    */
    private final int PWG_BASEFREQ = 111875;
    private final int TWG_BASEFREQ = 55938;
    private final int[] PITCH_LIST = { 3620,3840,4070,4310,4567,4838,5126,5431,5754,6094,6458,6842 };
    private final int PITCHRANGE_LOWER = 3420;
    private final int PITCHRANGE_HIGHER = 6842;
    private final byte MLD_OCTSHIFT_NONE = 0x00;
    private final byte MLD_OCTSHIFT_UP = 0x01;
    //private final byte MLD_OCTSHIFT_DOWN2 = 0x02;
    private final byte MLD_OCTSHIFT_DOWN = 0x03;
    private final int MLD_NOTERANGE_MAX = 62;
    private final int MLD_NOTERANGE_MIN = 0;

    /*JE^p̃JE^le[uBJE^120hz쓮Aȉ̓t[ŕ\L*/
    private final int[] lengthCounterValueTable = {
//          0x0A,0xFE,0x14,0x02,
//          0x28,0x04,0x50,0x06,
//          0xA0,0x08,0x3C,0x0A,
//          0x0E,0x0C,0x1A,0x0E,
//          0x0C,0x10,0x18,0x12,
//          0x30,0x14,0x60,0x16,
//          0xC0,0x18,0x48,0x1A,
//          0x10,0x1C,0x20,0x1E
            0x05,0x7F,0x0A,0x01,
            0x14,0x02,0x28,0x03,
            0x50,0x04,0x1E,0x05,
            0x07,0x06,0x0E,0x07,
            0x06,0x08,0x0C,0x09,
            0x18,0x0A,0x30,0x0B,
            0x60,0x0C,0x24,0x0D,
            0x08,0x0E,0x10,0x0F,
    };

    /*  }N      */
    private final int BITFLAG_SET = 1;
    private final int BITFLAG_CLEAR = 0;

    /*CX^Xϐ*/
    private final AudioPresenter ap_0,ap_1;  //ĐAudioPresenter.setsound()oȂ̂łQp
    private AudioPresenter ap;
    private int tracksize;
    private int trackframecount;
    private byte[] trackbuffer;
    private byte[] mldheader;
    private byte[] trackheader;

    private int audioMode;
    private boolean enableAudio;
    private boolean[] enableChannel = new boolean[4];
    private int[] presetInstNum = new int[4];

    /*WX^p[^*/
    /*PWG1 $4000 - $4003 */
    private int pwg1_dutyCycle;
    private int pwg1_disableLengthCounter;
    private int pwg1_disableEnvelope;
    private int pwg1_envelopeCycle;
    private int pwg1_enableSweep;
    private int pwg1_sweepCycle;
    private int pwg1_sweepModeNegative;
    private int pwg1_sweepShiftval;
    private int pwg1_deviderClock;
    private int pwg1_lengthCounterIndex;
    /*PWG2 $4004 - $4007 */
    private int pwg2_dutyCycle;
    private int pwg2_disableLengthCounter;
    private int pwg2_disableEnvelope;
    private int pwg2_envelopeCycle;
    private int pwg2_enableSweep;
    private int pwg2_sweepCycle;
    private int pwg2_sweepModeNegative;
    private int pwg2_sweepShiftval;
    private int pwg2_deviderClock;
    private int pwg2_lengthCounterIndex;
    /*TWG $4008 - $400B */
    private int twg_disableLengthCounter;
    private int twg_valueOfLinearCounter;
    private int twg_deviderClock;
    private int twg_lengthCounterIndex;
    /*NWG $400C - $400F */
    private int nwg_disableLengthCounter;
    private int nwg_disableEnvelope;
    private int nwg_envelopeCycle;
    private int nwg_generationMode;
    private int nwg_deviderClockIndex;
    private int nwg_lengthCounterIndex;
    /*DMC $4010 - $4013 */
    /*STATUS    $4015   */
    private int pwg1_enable;
    private int pwg2_enable;
    private int twg_enable;
    private int nwg_enable;
    /*SEQ,IRQ flags$4017*/

    /*G~[gp̓p[^*/
    private int pwg1_lengthCounter;
    private int pwg1_envelopeTimer;
    private int pwg1_envelopeCounter;
    private int pwg1_sweepTimer;
    private int pwg2_lengthCounter;
    private int pwg2_envelopeTimer;
    private int pwg2_envelopeCounter;
    private int pwg2_sweepTimer;
    private int twg_lengthCounter;
    private int twg_linearCounter;
    private int twg_disableLinearCounter;
    private int nwg_lengthCounter;
    private int nwg_envelopeTimer;
    private int nwg_envelopeCounter;

    /*  TEho͗p  */
    private int pwg1_dacOutput;
    private int pwg1_seqMode;
    private int pwg1_freq;
    private int pwg2_dacOutput;
    private int pwg2_seqMode;
    private int pwg2_freq;
    private int twg_dacOutput;
    private int twg_freq;
    private int nwg_dacOutput;
    private int nwg_seqMode;
    private int nwg_freq;
    
    public NESApu1(PSGi psgi_, int mode) {
        int instNum[] = new int[] { 24, 24, 24, 48 };;
        ap_0 = AudioPresenter.getAudioPresenter(0);
        ap_1 = AudioPresenter.getAudioPresenter(1);
        ap = ap_0;

        mldheader = loadLocalResouce("resource:///mldheader.mld");

        //JX^F
        for(int i=0;i < instNum.length;i++) {
            if(i >= presetInstNum.length) break;
            presetInstNum[i] = instNum[i] - 1;
        }
        setMode(mode);
        apu_enable(true);
        apu_reset();
        apu_setchan(CH_PWG1, true);
        apu_setchan(CH_PWG2, true);
        apu_setchan(CH_TWG, true);
        apu_setchan(CH_NWG, true);
    }

    public void apu_enable(boolean enable) {
        enableAudio = enable;
    }

    public void apu_setvol(int vol) {
        ap_0.setAttribute(AudioPresenter.SET_VOLUME, vol);
        ap_1.setAttribute(AudioPresenter.SET_VOLUME, vol);
    }

    public void apu_setting() {
        if (true) { // Config.apuEnable
            enableAudio = true;
            ap_0.setAttribute(AudioPresenter.SET_VOLUME, 100); //Config.volume
            ap_1.setAttribute(AudioPresenter.SET_VOLUME, 100); ////Config.volume
        } else {
            enableAudio = false;
        }
        enableChannel[0] = true; //!gui.channelOff_[0];
        enableChannel[1] = true; //!gui.channelOff_[1];
        enableChannel[2] = true; //!gui.channelOff_[2];
        enableChannel[3] = true; //!gui.channelOff_[3];
    }

    //APU2 API
    public void apu_setmode(int mode){}

    private void setMode(int mode) {
        switch(mode) {
        case MODE_YAMAHA :
            trackheader = loadLocalResouce("resource:///trackheader_n.mld");
            audioMode = MODE_YAMAHA;
            break;
        case MODE_ROHM :
            trackheader = loadLocalResouce("resource:///trackheader_p.mld");
            audioMode = MODE_ROHM;
            break;
        case MODE_CUSTOM :
            trackheader = loadCustomHeaderBytes();
            audioMode = MODE_CUSTOM;
            break;
        default :
            trackheader = loadLocalResouce("resource:///trackheader_preset.mld");
            audioMode = MODE_PRESET;
            break;
        }
    }

    public void apu_setchan(int ch, boolean enabled) {
        if(ch >= 4) return;
        enableChannel[ch] = enabled;
    }

    public void apu_emulate_frame() {
        if(!enableAudio) return;

        //1t[ƂɌĂяoăobt@ɏ
        if(trackbuffer == null) {
            trackbuffer = new byte[TRACKBUFFER_SIZE];
            tracksize = 0;
            trackframecount = 0;
        }

        byte[] data = generateMldSequence();
        System.arraycopy(data, 0, trackbuffer, tracksize, data.length);
        tracksize += data.length;
        trackframecount++;

        //t[Đ&obt@
        if(trackframecount >= TRACKBUFFER_MAXFRAMECOUNT) {
            byte[] mld = generateMldFromBuffer();
            playMld(mld);
            trackbuffer = null;
        }
    }

    private void playMld(byte[] mld) {
        if(audioMode != MODE_ROHM) {
            //AP؂ւ
            if(ap == ap_1) {
                ap = ap_0;
            } else {
                ap = ap_1;
            }
        }

        MediaSound mso = MediaManager.getSound(mld);
        try {
            mso.use();
            ap.stop();
        } catch (Exception e) {
            //System.out.println("NESAudio.playMld:"+e.toString());
        }
        ap.setSound(mso);
        ap.play();
    }

    public void apu_write(int addr, int data) {
        if(!enableAudio) return;
        switch(addr) {
        //Rectangle1
        case 0x4000:
            pwg1_dutyCycle = data >> 6 & 0x03;
            pwg1_disableLengthCounter = data >> 5 & 0x01;
            pwg1_disableEnvelope = data >> 4 & 0x01;
            pwg1_envelopeCycle = data & 0x0F;
            break;
        case 0x4001:
            pwg1_enableSweep = data >> 7 & 0x01;
            pwg1_sweepCycle = data >> 4 & 0x07;
            pwg1_sweepModeNegative = data >> 3 & 0x01;
            pwg1_sweepShiftval = data & 0x07;
            break;
        case 0x4002:
            pwg1_deviderClock = pwg1_deviderClock & ~0xFF | data & 0xFF;
            break;
        case 0x4003:
            pwg1_lengthCounterIndex = data >> 3 & 0x1F;
            pwg1_deviderClock = (data & 0x07) << 8 | pwg1_deviderClock & 0xFF;
            pwg1_sweepTimer = 0;
            pwg1_envelopeTimer = 0;
            pwg1_envelopeCounter = 0x0F;
            if(pwg1_enable == BITFLAG_SET) {
                pwg1_lengthCounter = lengthCounterValueTable[pwg1_lengthCounterIndex];
            }
            break;

        //Rectangle2
        case 0x4004:
            pwg2_dutyCycle = data >> 6 & 0x03;
            pwg2_disableLengthCounter = data >> 5 & 0x01;
            pwg2_disableEnvelope = data >> 4 & 0x01;
            pwg2_envelopeCycle = data & 0x0F;
            break;
        case 0x4005:
            pwg2_enableSweep = data >> 7 & 0x01;
            pwg2_sweepCycle = data >> 4 & 0x07;
            pwg2_sweepModeNegative = data >> 3 & 0x01;
            pwg2_sweepShiftval = data & 0x07;
            break;
        case 0x4006:
            pwg2_deviderClock = pwg2_deviderClock & ~0xFF | data & 0xFF;
            break;
        case 0x4007:
            pwg2_lengthCounterIndex = data >> 3 & 0x1F;
            pwg2_deviderClock = (data & 0x07) << 8 | pwg2_deviderClock & 0xFF;
            pwg2_sweepTimer = 0;
            pwg2_envelopeTimer = 0;
            pwg2_envelopeCounter = 0x0F;
            if(pwg2_enable == BITFLAG_SET) {
                pwg2_lengthCounter = lengthCounterValueTable[pwg2_lengthCounterIndex];
            }
            break;

        //Triangle
        case 0x4008:
            twg_disableLengthCounter = data >> 7 & 0x01;
            twg_valueOfLinearCounter = data & 0x7F;
            break;
        case 0x400A:
            twg_deviderClock = twg_deviderClock & ~0xFF | data & 0xFF;
            break;
        case 0x400B:
            twg_lengthCounterIndex = data >> 3 & 0x1F;
            twg_deviderClock = (data & 0x07) << 8 | twg_deviderClock & 0xFF;
            twg_disableLinearCounter = BITFLAG_SET;
            if(twg_enable == BITFLAG_SET) {
                twg_lengthCounter = lengthCounterValueTable[twg_lengthCounterIndex];
            }
            break;

        //Noise
        case 0x400C:
            nwg_disableLengthCounter = data >> 5 & 0x01;
            nwg_disableEnvelope = data >> 4 & 0x01;
            nwg_envelopeCycle = data & 0x0F;
            break;
        case 0x400E:
            nwg_generationMode = data >> 7 & 0x01;
            nwg_deviderClockIndex = data & 0x0F;
            break;
        case 0x400F:
            nwg_lengthCounterIndex = data >> 3 & 0x1F;
            nwg_envelopeTimer = 0;
            nwg_envelopeCounter = 0x0F;
            if(nwg_enable == BITFLAG_SET) {
                nwg_lengthCounter = lengthCounterValueTable[nwg_lengthCounterIndex];
            }
            break;

        //status_register
        case 0x4015:
            pwg1_enable = data & 0x01;
            pwg2_enable = data >> 1 & 0x01;
            twg_enable = data >> 2 & 0x01;
            nwg_enable = data >> 3 & 0x01;
            if(pwg1_enable == BITFLAG_CLEAR) pwg1_lengthCounter = 0;
            if(pwg2_enable == BITFLAG_CLEAR) pwg2_lengthCounter = 0;
            if(twg_enable == BITFLAG_CLEAR) twg_lengthCounter = 0;
            if(nwg_enable == BITFLAG_CLEAR) nwg_lengthCounter = 0;
            break;

        //
        //case 0x4017:
        //  disableFrameInterrupt = data >> 6 & 0x01;
        //  frameSequencerMode = data >> 7 & 0x01;
        //  break;
        }
    }

    public void apu_reset() {
        for(int i = 0x4000;i <= 0x4015; i++) {
            apu_write(i, 0x00);
        }
    }

    public int apu_read(int addr) {
        if(!enableAudio) return 0;
        int ret = 0;
        if(nwg_lengthCounter != 0) ret += 0x08;
        if(twg_lengthCounter != 0) ret += 0x04;
        if(pwg2_lengthCounter != 0) ret += 0x02;
        if(pwg1_lengthCounter != 0) ret += 0x01;
        return ret;
    }

    private byte[] generateMldFromBuffer() {
        //this.trackbufMLDt@C𐶐
        byte[] mldbuf = new byte[mldheader.length + trackheader.length + tracksize + 4];

        System.arraycopy(mldheader, 0, mldbuf, 0, mldheader.length);
        System.arraycopy(trackheader, 0, mldbuf, mldheader.length, trackheader.length);
        System.arraycopy(trackbuffer, 0, mldbuf, mldheader.length + trackheader.length, tracksize);

        //EndOfTrackǉ
        mldbuf[mldbuf.length - 4] = (byte)(MLD_NOTE_DURATION + 1);
        mldbuf[mldbuf.length - 3] = (byte)0xFF;
        mldbuf[mldbuf.length - 2] = (byte)0xDF;
        mldbuf[mldbuf.length - 1] = (byte)0x00;

        //trac̗eʌvZMLDɏ
        //(trackheader.length + tracksize + 4) -8  gbNTCY
        int tracksizesum = (trackheader.length + tracksize - 4);
        mldbuf[mldheader.length + 4] = (byte)(tracksizesum >> 24);
        mldbuf[mldheader.length + 5] = (byte)(tracksizesum >> 16);
        mldbuf[mldheader.length + 6] = (byte)(tracksizesum >> 8);
        mldbuf[mldheader.length + 7] = (byte)(tracksizesum >> 0);

        //MLD̗eʌvZMLDf[^ɏ
        mldbuf[4] = (byte)((mldbuf.length - 8) >> 24);
        mldbuf[5] = (byte)((mldbuf.length - 8) >> 16);
        mldbuf[6] = (byte)((mldbuf.length - 8) >> 8);
        mldbuf[7] = (byte)((mldbuf.length - 8) >> 0);

        return mldbuf;
    }

    private byte[] generateMldSequence() {
        //MLDo͗p
        int ch_ProgramNum[] = new int[4];
        int ch_NoteNum[] = new int[4];
        int ch_OctShift[] = new int[4];

        byte nop[] =  {
                (byte)MLD_NOTE_DURATION,
                (byte)0xFF,
                (byte)0xDE,
                (byte)0x00
        };

        int datasize = 0;
        int count = 0;
        byte[] data;

        operateApu();

        /*o̓f[^TCYvZ*/
        if(enableChannel[CH_PWG1] && pwg1_dacOutput > 0) datasize += 8;
        if(enableChannel[CH_PWG2] && pwg2_dacOutput > 0) datasize += 8;
        if(enableChannel[CH_TWG] && twg_dacOutput > 0) datasize += 8;
        if(enableChannel[CH_NWG] && nwg_dacOutput > 0) datasize += 8;

        if(datasize == 0) return nop;       //NOPV[PXo

        if(audioMode == MODE_YAMAHA || audioMode == MODE_ROHM) datasize += 16;

        data = new byte[datasize];

        /*o͗pvZ*/
        //F
        ch_ProgramNum[CH_PWG1] = pwg1_seqMode;
        ch_ProgramNum[CH_PWG2] = pwg2_seqMode;
        ch_ProgramNum[CH_NWG] = nwg_seqMode;
        //MLDm[giovZ
        ch_NoteNum[CH_PWG1] = freqToNotenum(pwg1_freq);
        ch_NoteNum[CH_PWG2] = freqToNotenum(pwg2_freq);
        ch_NoteNum[CH_TWG] = freqToNotenum(twg_freq);
        ch_NoteNum[CH_NWG] = nwg_freq;
        //IN^[uVtg
        for(int i=0;i<4;i++) {
            if(ch_NoteNum[i] < MLD_NOTERANGE_MIN) {
                ch_NoteNum[i] += 12;
                ch_OctShift[i] = MLD_OCTSHIFT_DOWN;
            } else if(ch_NoteNum[i]  > MLD_NOTERANGE_MAX) {
                ch_NoteNum[i] -= 12;
                ch_OctShift[i] = MLD_OCTSHIFT_UP;
            } else {
                ch_OctShift[i] = MLD_OCTSHIFT_NONE;
            }
        }
        /*
        //mCY`lႢ
        switch(audioMode) {
        case MODE_YAMAHA :
            ch_OctShift[3] = MLD_OCTSHIFT_NONE;
            break;
        case MODE_ROHM :
            ch_OctShift[3] = MLD_OCTSHIFT_DOWN;
            break;
        default :
            ch_OctShift[3] = MLD_OCTSHIFT_DOWN;
            break;
        }
        */

        /*MLD*/
        if(audioMode == MODE_YAMAHA || audioMode == MODE_ROHM) {
            data[count++] = (byte)0x00;
            data[count++] = (byte)0xFF;
            data[count++] = (byte)0xE0;
            data[count++] = (byte)(MLD_PWG_PROGRAMNUM[ch_ProgramNum[CH_PWG1]] & 0x3F);
            data[count++] = (byte)0x00;
            data[count++] = (byte)0xFF;
            data[count++] = (byte)0xE0;
            data[count++] = (byte)(0x40 | MLD_PWG_PROGRAMNUM[ch_ProgramNum[CH_PWG2]] & 0x3F);
            data[count++] = (byte)0x00;
            data[count++] = (byte)0xFF;
            data[count++] = (byte)0xE0;
            data[count++] = (byte)(0x80 | MLD_TWG_PROGRAMNUM & 0x3F);
            data[count++] = (byte)0x00;
            data[count++] = (byte)0xFF;
            data[count++] = (byte)0xE0;
            data[count++] = (byte)(0xC0 | MLD_NWG_PROGRAMNUM[ch_ProgramNum[CH_NWG]] & 0x3F);
        }

        if(enableChannel[CH_PWG1] && pwg1_dacOutput != 0) {
            data[count++] = (byte)0x00;
            data[count++] = (byte)0xFF;
            data[count++] = (byte)0xE2;
            data[count++] = (byte)(MLD_PWG_VOL[pwg1_dacOutput] & 0x3F);
            data[count++] = (byte)0x00;
            data[count++] = (byte)(ch_NoteNum[CH_PWG1] & 0x3F);
            data[count++] = (byte)(MLD_NOTE_DURATION + 1);
            data[count++] = (byte)(MLD_NOTEVELOCITY_VAL | (ch_OctShift[CH_PWG1] & 0x03));
        }

        if(enableChannel[CH_PWG2] && pwg2_dacOutput != 0) {
            data[count++] = (byte)0x00;
            data[count++] = (byte)0xFF;
            data[count++] = (byte)0xE2;
            data[count++] = (byte)(0x40 | MLD_PWG_VOL[pwg2_dacOutput] & 0x3F);
            data[count++] = (byte)0x00;
            data[count++] = (byte)(0x40 | ch_NoteNum[CH_PWG2] & 0x3F);
            data[count++] = (byte)(MLD_NOTE_DURATION + 1);
            data[count++] = (byte)(MLD_NOTEVELOCITY_VAL | (ch_OctShift[CH_PWG2] & 0x03));
        }

        if(enableChannel[CH_TWG] && twg_dacOutput != 0) {
            data[count++] = (byte)0x00;
            data[count++] = (byte)0xFF;
            data[count++] = (byte)0xE2;
            data[count++] = (byte)(0x80 | MLD_TWG_VOL[twg_dacOutput] & 0x3F);
            data[count++] = (byte)0x00;
            data[count++] = (byte)(0x80 | ch_NoteNum[CH_TWG] & 0x3F);
            data[count++] = (byte)(MLD_NOTE_DURATION + 1);
            data[count++] = (byte)(MLD_NOTEVELOCITY_VAL | (ch_OctShift[CH_TWG] & 0x03));
        }

        if(enableChannel[CH_NWG] && nwg_dacOutput != 0) {
            data[count++] = (byte)0x00;
            data[count++] = (byte)0xFF;
            data[count++] = (byte)0xE2;
            data[count++] = (byte)(0xC0 | MLD_NWG_VOL[nwg_dacOutput] & 0x3F);
            data[count++] = (byte)0x00;
            data[count++] = (byte)(0xC0 | MLD_NWG_NOTENUM[ch_NoteNum[CH_NWG]] & 0x3F);
            data[count++] = (byte)(MLD_NOTE_DURATION + 1);
            data[count++] = (byte)(MLD_NOTEVELOCITY_VAL | (ch_OctShift[CH_NWG] & 0x03));
        }

        data[0] = (byte)MLD_NOTE_DURATION;      //t[̐擪f[^^C炷

        return data;
    }

    private void operateApu() {
        //XEB[p
        if(pwg1_enableSweep == BITFLAG_SET && pwg1_sweepShiftval > 0 && pwg1_lengthCounter > 0 ) {
            pwg1_sweepTimer += 2;
            while(pwg1_sweepTimer / (pwg1_sweepCycle+1) > 0) {
                if(pwg1_sweepModeNegative == BITFLAG_SET) {
                    pwg1_deviderClock -= pwg1_deviderClock >> pwg1_sweepShiftval;
                }
                else {
                    pwg1_deviderClock += pwg1_deviderClock >> pwg1_sweepShiftval;
                }

                pwg1_sweepTimer -= (pwg1_sweepCycle+1);

                if(pwg1_deviderClock <= 8) {
                    pwg1_deviderClock = 0x08;
                    pwg1_lengthCounter = 0;
                }
                if(pwg1_deviderClock >= 0x7FF) {
                    pwg1_deviderClock = 0x7FF;
                    pwg1_lengthCounter = 0;
                }
            }
        }

        if(pwg2_enableSweep == BITFLAG_SET && pwg2_sweepShiftval > 0 && pwg2_lengthCounter > 0 ) {
            pwg2_sweepTimer += 2;
            while(pwg2_sweepTimer / (pwg2_sweepCycle+1) > 0) {
                if(pwg2_sweepModeNegative == BITFLAG_SET) {
                    pwg2_deviderClock -= (pwg2_deviderClock >> pwg2_sweepShiftval) - 1;
                }
                else {
                    pwg2_deviderClock += pwg2_deviderClock >> pwg2_sweepShiftval;
                }

                pwg2_sweepTimer -= (pwg2_sweepCycle+1);

                if(pwg2_deviderClock <= 8) {
                    pwg2_deviderClock = 0x08;
                    pwg2_lengthCounter = 0;
                }
                if(pwg2_deviderClock >= 0x7FF) {
                    pwg2_deviderClock = 0x7FF;
                    pwg2_lengthCounter = 0;
                }
            }
        }

        //sb`vZ
        pwg1_freq = PWG_BASEFREQ / (pwg1_deviderClock + 1);
        pwg2_freq = PWG_BASEFREQ / (pwg2_deviderClock + 1);
        twg_freq = TWG_BASEFREQ / (twg_deviderClock + 1);
        nwg_freq = nwg_deviderClockIndex;

        //V[PX[h
        pwg1_seqMode = pwg1_dutyCycle;
        pwg2_seqMode = pwg2_dutyCycle;
        nwg_seqMode = nwg_generationMode;

        //{[vZ
        /*`g1*/
        if(pwg1_disableLengthCounter == BITFLAG_CLEAR && pwg1_lengthCounter > 0) pwg1_lengthCounter--;

        if(pwg1_lengthCounter == 0) {
            pwg1_dacOutput = 0;
        } else {
            if(pwg1_disableEnvelope == BITFLAG_SET) {
                pwg1_dacOutput = pwg1_envelopeCycle;
            }
            else {
                pwg1_envelopeTimer += 4;
                while(pwg1_envelopeTimer / (pwg1_envelopeCycle+1) > 0) {
                    pwg1_envelopeCounter--;

                    if(pwg1_envelopeCounter < 0) {
                        if(pwg1_disableLengthCounter == BITFLAG_SET) {
                            pwg1_envelopeCounter = 15;
                        }
                        else {
                            pwg1_envelopeCounter = 0;
                        }
                    }

                    pwg1_envelopeTimer -= pwg1_envelopeCycle + 1;
                }
                pwg1_dacOutput = pwg1_envelopeCounter;
            }
        }

        /*`g2*/
        if(pwg2_disableLengthCounter == BITFLAG_CLEAR && pwg2_lengthCounter > 0) pwg2_lengthCounter--;

        if(pwg2_lengthCounter == 0) {
            pwg2_dacOutput = 0;
        } else {
            if(pwg2_disableEnvelope == BITFLAG_SET) {
                pwg2_dacOutput = pwg2_envelopeCycle;
            }
            else {
                pwg2_envelopeTimer += 4;
                while(pwg2_envelopeTimer / (pwg2_envelopeCycle+1) > 0) {
                    pwg2_envelopeCounter--;

                    if(pwg2_envelopeCounter < 0) {
                        if(pwg2_disableLengthCounter == BITFLAG_SET) {
                            pwg2_envelopeCounter = 15;
                        }
                        else {
                            pwg2_envelopeCounter = 0;
                        }
                    }

                    pwg2_envelopeTimer -= pwg2_envelopeCycle + 1;
                }
                pwg2_dacOutput = pwg2_envelopeCounter;
            }
        }

        /*Opg*/
        if(twg_disableLinearCounter == BITFLAG_SET) {
            twg_linearCounter = (twg_valueOfLinearCounter+3)/4;
        }
        else if(twg_linearCounter > 0) {
            twg_linearCounter--;
        }

        if(twg_disableLengthCounter == BITFLAG_CLEAR) {
            if(twg_lengthCounter > 0) twg_lengthCounter--;
            twg_disableLinearCounter = BITFLAG_CLEAR;
        }

        if(twg_lengthCounter > 0 && twg_linearCounter > 0) {
            twg_dacOutput = 0x01;
        } else {
            twg_dacOutput = 0x00;
        }

        /*mCY*/
        if(nwg_disableLengthCounter == BITFLAG_CLEAR && nwg_lengthCounter > 0) nwg_lengthCounter--;

        if(nwg_lengthCounter == 0) {
            nwg_dacOutput = 0;
        } else {
            if(nwg_disableEnvelope == BITFLAG_SET) {
                nwg_dacOutput = nwg_envelopeCycle;
            }
            else {
                nwg_envelopeTimer += 4;
                while(nwg_envelopeTimer / (nwg_envelopeCycle+1) > 0) {
                    nwg_envelopeCounter--;

                    if(nwg_envelopeCounter < 0) {
                        if(nwg_disableLengthCounter == BITFLAG_SET) {
                            nwg_envelopeCounter = 15;
                        }
                        else {
                            nwg_envelopeCounter = 0;
                        }
                    }

                    nwg_envelopeTimer -= nwg_envelopeCycle + 1;
                }
                nwg_dacOutput = nwg_envelopeCounter;
            }
        }
    }

    private int freqToNotenum(int freq) {
        //g特No.ɕϊB(V˓I_C^CcB
        //(Ԃl) -12 `74
        int noteNum = 0;
        int steps = 0;

        if(freq < PITCHRANGE_LOWER) {
            while(freq < PITCHRANGE_LOWER) {
                freq *= 2;
                steps++;
            }
        }
        else if(freq > PITCHRANGE_HIGHER) {
            while(freq > PITCHRANGE_HIGHER) {
                freq /= 2;
                steps--;
            }
        }

        for(int i=0;i<12;i++) {
            if(freq < PITCH_LIST[i]) {
                noteNum = i + 12 * (5 - steps);
                break;
            }
        }

        //Đs\
        if(noteNum < -12 || noteNum > 74) noteNum = 75;

        return noteNum;
    }

    private byte[] loadLocalResouce (String location) {
        int datasize = 0;
        byte[] buf = new byte[1200];
        byte[] data;

        try {
            InputStream is = Connector.openDataInputStream(location);
            datasize = is.read(buf);
            is.close();
        }
        catch (IOException e){
            //System.out.println("NESAudio.loadResouce:"+e.toString());
        }

        data = new byte[datasize];
        System.arraycopy(buf, 0, data, 0, data.length);
        return data;
    }

    private byte[] loadCustomHeaderBytes() {
        byte[] seq = {
                (byte)0x00,
                (byte)0xFF,
                (byte)0xE1,
                (byte)0x00,
                (byte)0x00,
                (byte)0xFF,
                (byte)0xE0,
                (byte)0x00
        };

        int pos;
        byte[] header;
        byte[] data;

        header = loadLocalResouce("resource:///trackheader_custom.mld");

        data = new byte[header.length + seq.length * 4];

        System.arraycopy(header, 0, data, 0, header.length);
        pos = header.length;

        seq[3] = (byte)(0x02 | (presetInstNum[CH_PWG1] >> 6 & 0x01));
        seq[7] = (byte)(0x00 | (presetInstNum[CH_PWG1] & 0x3F));
        System.arraycopy(seq, 0, data, pos, seq.length);
        pos += seq.length;

        seq[3] = (byte)(0x42 | (presetInstNum[CH_PWG2] >> 6 & 0x01));
        seq[7] = (byte)(0x40 | (presetInstNum[CH_PWG2] & 0x3F));
        System.arraycopy(seq, 0, data, pos, seq.length);
        pos += seq.length;

        seq[3] = (byte)(0x82 | (presetInstNum[CH_TWG] >> 6 & 0x01));
        seq[7] = (byte)(0x80 | (presetInstNum[CH_TWG] & 0x3F));
        System.arraycopy(seq, 0, data, pos, seq.length);
        pos += seq.length;

        seq[3] = (byte)(0xC2 | (presetInstNum[CH_NWG] >> 6 & 0x01));
        seq[7] = (byte)(0xC0 | (presetInstNum[CH_NWG] & 0x3F));
        System.arraycopy(seq, 0, data, pos, seq.length);

        return data;
    }
}
