package wsx2.dojapcmsound;

import java.io.*;
import javax.microedition.io.Connector;
import com.nttdocomo.ui.*;

public abstract class PcmAudioHandler {


	public static final int MODE_N505i = 0;
	public static final int MODE_SH252i = 1;
	public static final int MODE_SA702i= 2;
	
	protected static final AudioPresenter conap1 = AudioPresenter.getAudioPresenter();
	protected static final AudioPresenter conap2 = AudioPresenter.getAudioPresenter();
	protected final AudioPresenter ap1,ap2;
	protected AudioPresenter ap;
	protected byte[] outbuf;
	protected int bufferredSampleCount;
	protected int sampleRate;
	
	protected PcmAudioHandler () {
		ap1 = conap1;
		ap2 = conap2;
		ap = ap1;
		
		sampleRate = 8000;
	}			
	
	public static PcmAudioHandler getPCMHandler(int mode) {
		switch(mode) {
		case MODE_N505i:
			return new PcmAudioHandler_N505i();
		case MODE_SH252i:
			return new PcmAudioHandler_SH252i();
		case MODE_SA702i:
			return new PcmAudioHandler_SA702i();
		default: return null;
		}
	}	

	/**
	 * writeSample \bhɂď܂ꂽPCMĐ܂B
	 * Ōɂ̃\bhɂčĐꂽĐłꍇA
	 * ̍Đ~ōĐJn܂B
	 * ĐAݍς݂PCMTvobt@̓NA܂B
	 * obt@NAꂽԂA
	 * Tvobt@ɉ܂ĂȂԂŌĂяoꂽꍇA
	 * ܂B
	 */
	public void play() {
		MediaSound mso;
		
		if(bufferredSampleCount == 0)return;
		
		//AP؂ւ
		if(ap == ap1) 
			ap = ap1;
		else 
			ap = ap2;
		
		mso = MediaManager.getSound(getMld());
		
		try {
			mso.use();
			ap.stop();
		} catch (Exception e) {
			System.out.println(e.toString());
		} 
		
		ap.setSound(mso);
		ap.play();
		
		clearSample();
	}
	
	/**
	 * Ōplay \bhɂčĐꂽPCM̍Đ~܂B
	 * ̃\bȟĂяoȑOɉĐĂȂꍇA
	 * ĐɏIĂꍇ͉܂B
	 */
	public void stop() {
			ap.stop();	//MediaDataZbgĂȂAAuse()ĂȂƂ́H
	}
	
	public void setVolume(int vol) {
		if(vol < 0 || vol > 100) return;
		
		ap1.setAttribute(AudioPresenter.SET_VOLUME, vol);
		ap2.setAttribute(AudioPresenter.SET_VOLUME, vol);
	}
	
	/**
	 * writeSample\bhɂďݍς݂̓PCMTvobt@NA܂B
	 */
	public void clearSample() {
		bufferredSampleCount = 0;
	}
	
	/**
	 * 16bitPCMTvݐݒ肳Ă郂[hɂēobt@֏݂܂B
	 * Ɏw肳ꂽĺA-32768`+32767 ̒l16bitlƂď܂B
	 * K̃Tv𒴂ďƂꍇ͉܂B
	 * @param sample - PCMTv𕄍t16bitlƂĎw肵܂B
	 */
	public abstract void writeSample(int sample);
	
	public void setSampleRate(int rate) {
		switch(rate) {
		case 8000:
		case 16000:
		case 32000:
			sampleRate = rate;
			clearSample();
		}
	}
	
	public int getSampleRate() {
		return sampleRate;
	}

	protected abstract byte[] getMld();
	
	protected static byte[] loadLocalResouce (String location) {
		int datasize = 0;
		byte[] buf = new byte[30000];
		byte[] data;

		try {
			InputStream is = Connector.openDataInputStream(location);
			datasize = is.read(buf);
			is.close();
		}
		catch (IOException e){
			System.out.println(e.toString());
		}

		data = new byte[datasize];
		System.arraycopy(buf, 0, data, 0, data.length);
		return data;
	}

//	public static void outputData(byte[] data) {
//		try {
//			DataOutputStream dos = Connector.openDataOutputStream("scratchpad:///0;pos=0");
//			dos.write(data);
//			dos.close();
//			dos = null;
//		} catch(Exception e) {
//			System.out.println(e.toString());
//		}
//	}
}
